﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace InfoSistem.Student
{
    public partial class frmPromenaPretragaStudenata : Form
    {
        public frmPromenaPretragaStudenata()
        {
            InitializeComponent();
        }

        private void studentBindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            this.Validate();
            this.studentBindingSource.EndEdit();
            this.tableAdapterManager.UpdateAll(this.eTS_NT_PRAKSADataSet);

        }

        private void frmPromenaPretragaStudenata_Load(object sender, EventArgs e)
        {
            
            this.studentTableAdapter.Fill(this.eTS_NT_PRAKSADataSet.student);

            this.student_predmetTableAdapter1.Fill(this.eTS_NT_PRAKSADataSet.student_predmet);

            this.predmetTableAdapter1.Fill(this.eTS_NT_PRAKSADataSet.predmet);

            this.zapisnikTableAdapter1.Fill(this.eTS_NT_PRAKSADataSet.zapisnik);
        }

        private void btnSacuvaj_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Da li ste sigurni", "Potvrda", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
            {
                tabControl1.SelectTab(0);

                studentBindingSource.EndEdit();

                studentTableAdapter.Update(eTS_NT_PRAKSADataSet.student);

            }
        }

        private void btnPrikaziPredmete_Click(object sender, EventArgs e)
        {


            int idStudenta = Convert.ToInt32(iD_STUDENTATextBox.Text);

            // [1589, 2002, 3567]
            var predmetiStudenta = eTS_NT_PRAKSADataSet.student_predmet
                                   .Where(sp => sp.ID_STUDENTA == idStudenta)
                                   .Select(sp => sp.ID_PREDMETA)
                                   .ToList();

            var naziviPredmeta = eTS_NT_PRAKSADataSet.predmet
                                 .Where(p => predmetiStudenta.Contains(p.ID_PREDMETA))
                                 .Select(p => new { naziv = p.NAZIV } )
                                 .ToList();

            dtgPredmeti.DataSource = naziviPredmeta;

        }

        private void btnPrikaziProsecnuOcenu_Click(object sender, EventArgs e)
        {
            int idStudenta = Convert.ToInt32(iD_STUDENTATextBox.Text);

            var prosecnaOcena = eTS_NT_PRAKSADataSet.zapisnik
                                .Where(z => z.ID_STUDENTA == idStudenta && z.OCENA > 5)
                                .Select(z => z.OCENA)
                                .Average();

            label2.Text = "Prosecna ocena studenta je: " + prosecnaOcena.ToString();
            
            label2.Visible = true;
        }

        private void btnDodajPredmetuStudentu_Click(object sender, EventArgs e)
        {

            int idStudenta = Convert.ToInt32(iD_STUDENTATextBox.Text);

            var predmetiStudenta = eTS_NT_PRAKSADataSet.student_predmet
                                   .Where(sp => sp.ID_STUDENTA == idStudenta)
                                   .Select(sp => sp.ID_PREDMETA)
                                   .ToList();


            var predmeti = eTS_NT_PRAKSADataSet.predmet
                           .Where(p => !predmetiStudenta.Contains(p.ID_PREDMETA))
                           .Select(p => new { id = p.ID_PREDMETA, naziv = p.NAZIV })
                           .ToList();


            cmbPredmeti.DataSource = predmeti;
            cmbPredmeti.DisplayMember = "naziv";
            cmbPredmeti.ValueMember = "id";


            tabControl1.SelectTab(2);

        }

        private void btnDodaj_Click(object sender, EventArgs e)
        {
            int idStudenta = Convert.ToInt32(iD_STUDENTATextBox.Text);

            // "2024/25"
            //                     2024                 + / +              2025
            string datum = DateTime.Now.Year.ToString() + "/" + (DateTime.Now.Year + 1).ToString().Substring(2, 2);

            student_predmetTableAdapter1.Insert(idStudenta, (short)cmbPredmeti.SelectedValue, datum);

            student_predmetTableAdapter1.Fill(eTS_NT_PRAKSADataSet.student_predmet);

            //MessageBox.Show(cmbPredmeti.SelectedValue.ToString());

        }

        private void polozeniPredmetiToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPolozeniPredmeti frm = new frmPolozeniPredmeti();
            frm.Show();
        }

        private void frmPromenaPretragaStudenata_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                contextMenuStrip1.Show(this, e.Location);

            }
          


        }
    }
}